searchNodes=[{"doc":"The Starship Webserver. This module is the starting point for the Starship Webserver. If you are an end user of Starship, this is the only thing that you need to worry about. Here is where you will warp_in your configuration (or use the default configuration provided) and start the webserver. A Note On SSL You may pass in options to the configuration of Starship that allow you to use SSL secured connections to connect to the server. The SSL options are passed directly into the Erlang SSL Application when the webserver is started, and on all requests, an SSL handshake will be initiated using the certificates and keys that you provided in the initial configuration. The SSL options should look something like this: ssl_opts = [ { :cacertfile , &quot;cacerts.pem&quot; } , { :certfile , &quot;cert.pem&quot; } , { :keyfile , &quot;key.pem&quot; } ]","ref":"Starship.html","title":"Starship","type":"module"},{"doc":"Validates the configuration and adds any of the missing required information. ## Examples iex(1)&gt; config = %{ } %{ } iex(2)&gt; Starship . validate_config! ( config ) %{ hosts : %{ { :http , &quot;*&quot; } =&gt; { Starship.Handler.Wildcard.Http , %{ } } , { :ws , &quot;*&quot; } =&gt; { Starship.Handler.Wildcard.Websocket , %{ } } } , ip : { 0 , 0 , 0 , 0 } , port : 4000 , ssl_opts : nil } iex(3)&gt; config = ...(3)&gt; %{ ...(3)&gt; ip : { 1 , 2 , 3 , 4 } ...(3)&gt; } %{ ip : { 1 , 2 , 3 , 4 } } iex(4)&gt; Starship . validate_config! ( config ) %{ hosts : %{ { :http , &quot;*&quot; } =&gt; { Starship.Handler.Wildcard.Http , %{ } } , { :ws , &quot;*&quot; } =&gt; { Starship.Handler.Wildcard.Websocket , %{ } } } , ip : { 1 , 2 , 3 , 4 } , port : 4000 , ssl_opts : nil } iex(5)&gt; config = ...(5)&gt; %{ ...(5)&gt; ip : { 1 , 2 , 3 , 4 } , ...(5)&gt; port : 4001 ...(5)&gt; } %{ ip : { 1 , 2 , 3 , 4 } , port : 4001 } iex(6)&gt; Starship . validate_config! ( config ) %{ hosts : %{ { :http , &quot;*&quot; } =&gt; { Starship.Handler.Wildcard.Http , %{ } } , { :ws , &quot;*&quot; } =&gt; { Starship.Handler.Wildcard.Websocket , %{ } } } , ip : { 1 , 2 , 3 , 4 } , port : 4001 , ssl_opts : nil } iex(7)&gt; config = ...(7)&gt; %{ ...(7)&gt; ip : { 1 , 2 , 3 , 4 } , ...(7)&gt; port : 4001 , ...(7)&gt; hosts : %{ ...(7)&gt; { :http , &quot;*&quot; } =&gt; { A.Different.Handler , %{ } } ...(7)&gt; } ...(7)&gt; } %{ hosts : %{ { :http , &quot;*&quot; } =&gt; { A.Different.Handler , %{ } } , } , ip : { 1 , 2 , 3 , 4 } , port : 4001 } iex(8)&gt; Starship . validate_config! ( config ) %{ hosts : %{ { :http , &quot;*&quot; } =&gt; { A.Different.Handler , %{ } } , { :ws , &quot;*&quot; } =&gt; { Starship.Handler.Wildcard.Websocket , %{ } } } , ip : { 1 , 2 , 3 , 4 } , port : 4001 , ssl_opts : nil } iex(9)&gt; config = ...(9)&gt; %{ ...(9)&gt; ip : { 1 , 2 , 3 , 4 } , ...(9)&gt; port : 4001 , ...(9)&gt; hosts : %{ ...(9)&gt; { :http , &quot;wow&quot; } =&gt; { A.Different.Handler , %{ } } ...(9)&gt; } ...(9)&gt; } %{ hosts : %{ { :http , &quot;wow&quot; } =&gt; { A.Different.Handler , %{ } } , } , ip : { 1 , 2 , 3 , 4 } , port : 4001 } iex(10)&gt; Starship . validate_config! ( config ) %{ hosts : %{ { :http , &quot;wow&quot; } =&gt; { A.Different.Handler , %{ } } , { :http , &quot;*&quot; } =&gt; { Starship.Handler.Wildcard.Http , %{ } } , { :ws , &quot;*&quot; } =&gt; { Starship.Handler.Wildcard.Websocket , %{ } } } , ip : { 1 , 2 , 3 , 4 } , port : 4001 , ssl_opts : nil }","ref":"Starship.html#validate_config!/1","title":"Starship.validate_config!/1","type":"function"},{"doc":"Starts the Starship webserver with the default configuration. The default configuration listens on port 4000, with wildcard handlers that receive requests for any host, Starship.Handler.Wildcard.Http and Starship.Handler.Wildcard.Websocket . Examples iex&gt; pid = Starship . warp_in ( ) iex&gt; is_pid ( pid ) true iex&gt; Process . exit ( pid , :closed )","ref":"Starship.html#warp_in/0","title":"Starship.warp_in/0","type":"function"},{"doc":"Starts the webserver with the desired configuration. The config passed to this function should be a map containing any configurations that you would like to start your webserver with. Examples iex(1)&gt; config = ...(1)&gt; %{ ...(1)&gt; ip : { 0 , 0 , 0 , 0 } , ...(1)&gt; port : 4000 , ...(1)&gt; hosts : %{ ...(1)&gt; { :http , &quot;*&quot; } =&gt; { Starship.Handler.Wildcard.Http , %{ } } , ...(1)&gt; { :ws , &quot;*&quot; } =&gt; { Starship.Handler.Wildcard.Websocket , %{ } } ...(1)&gt; } , ...(1)&gt; ssl_opts : nil ...(1)&gt; } %{ ip : { 0 , 0 , 0 , 0 } , port : 4000 , hosts : %{ { :http , &quot;*&quot; } =&gt; { Starship.Handler.Wildcard.Http , %{ } } , { :ws , &quot;*&quot; } =&gt; { Starship.Handler.Wildcard.Websocket , %{ } } } , ssl_opts : nil } iex(2)&gt; pid = Starship . warp_in ( config ) iex(3)&gt; is_pid ( pid ) true iex(4)&gt; Process . exit ( pid , :closed )","ref":"Starship.html#warp_in/1","title":"Starship.warp_in/1","type":"function"},{"doc":"The TCP Acceptor used by the Starship Webserver. A Starship.Drive is started by the Starship.Drive.Engine per open socket.","ref":"Starship.Drive.html","title":"Starship.Drive","type":"module"},{"doc":"The main event loop for the Starship.Drive process. This loop listens for messages and spawns a Starship.Reactor process per request that arrives on the socket.","ref":"Starship.Drive.html#loop/1","title":"Starship.Drive.loop/1","type":"function"},{"doc":"The TCP Acceptor supervisor, which spawns and supervises Starship.Drive processes to handle the requests to the Starship Webserver.","ref":"Starship.Drive.Engine.html","title":"Starship.Drive.Engine","type":"module"},{"doc":"","ref":"Starship.Drive.Engine.html#loop/1","title":"Starship.Drive.Engine.loop/1","type":"function"},{"doc":"","ref":"Starship.Drive.Engine.html#start/1","title":"Starship.Drive.Engine.start/1","type":"function"},{"doc":"A simple wildcard handler for HTTP Requests that always returns 404 Not Found responses.","ref":"Starship.Handler.Wildcard.Http.html","title":"Starship.Handler.Wildcard.Http","type":"module"},{"doc":"","ref":"Starship.Handler.Wildcard.Http.html#http/2","title":"Starship.Handler.Wildcard.Http.http/2","type":"function"},{"doc":"A simple wildcard handler for redirecting HTTP requests from non-secured to secured endpoints.","ref":"Starship.Handler.Wildcard.Http.Redirect.html","title":"Starship.Handler.Wildcard.Http.Redirect","type":"module"},{"doc":"","ref":"Starship.Handler.Wildcard.Http.Redirect.html#http/2","title":"Starship.Handler.Wildcard.Http.Redirect.http/2","type":"function"},{"doc":"A simple wildcard handler for Websocket Requests that always sends &quot;Returning: &quot; followed by the text that is sent to the socket.","ref":"Starship.Handler.Wildcard.Websocket.html","title":"Starship.Handler.Wildcard.Websocket","type":"module"},{"doc":"Callback implementation for Starship.Handlers.Websocket.connect/2 .","ref":"Starship.Handler.Wildcard.Websocket.html#connect/2","title":"Starship.Handler.Wildcard.Websocket.connect/2","type":"function"},{"doc":"A behaviour module fo use when creating HTTP handlers for the Starship Webserver.","ref":"Starship.Handlers.Http.html","title":"Starship.Handlers.Http","type":"module"},{"doc":"A behaviour module fo use when creating HTTP handlers for the Starship Webserver.","ref":"Starship.Handlers.Websocket.html","title":"Starship.Handlers.Websocket","type":"behaviour"},{"doc":"","ref":"Starship.Handlers.Websocket.html#c:connect/2","title":"Starship.Handlers.Websocket.connect/2","type":"callback"},{"doc":"","ref":"Starship.Handlers.Websocket.html#c:handle_binary/2","title":"Starship.Handlers.Websocket.handle_binary/2","type":"callback"},{"doc":"","ref":"Starship.Handlers.Websocket.html#c:handle_close/2","title":"Starship.Handlers.Websocket.handle_close/2","type":"callback"},{"doc":"","ref":"Starship.Handlers.Websocket.html#c:handle_text/2","title":"Starship.Handlers.Websocket.handle_text/2","type":"callback"},{"doc":"The main request handler for the Starship Webserver. When a message is passed to a Starship.Drive process, a Starship.Reactor process is spawned to handle the request.","ref":"Starship.Reactor.html","title":"Starship.Reactor","type":"module"},{"doc":"","ref":"Starship.Reactor.html#build_conn/2","title":"Starship.Reactor.build_conn/2","type":"function"},{"doc":"","ref":"Starship.Reactor.html#get_host_handler/4","title":"Starship.Reactor.get_host_handler/4","type":"function"},{"doc":"","ref":"Starship.Reactor.html#handle_request/3","title":"Starship.Reactor.handle_request/3","type":"function"},{"doc":"","ref":"Starship.Reactor.html#header_too_large/1","title":"Starship.Reactor.header_too_large/1","type":"function"},{"doc":"","ref":"Starship.Reactor.html#http_version_not_supported/1","title":"Starship.Reactor.http_version_not_supported/1","type":"function"},{"doc":"","ref":"Starship.Reactor.html#loop/1","title":"Starship.Reactor.loop/1","type":"function"},{"doc":"","ref":"Starship.Reactor.html#method_not_allowed/1","title":"Starship.Reactor.method_not_allowed/1","type":"function"},{"doc":"","ref":"Starship.Reactor.html#on_close/1","title":"Starship.Reactor.on_close/1","type":"function"},{"doc":"","ref":"Starship.Reactor.html#on_tcp/2","title":"Starship.Reactor.on_tcp/2","type":"function"},{"doc":"","ref":"Starship.Reactor.html#on_ws_send/2","title":"Starship.Reactor.on_ws_send/2","type":"function"},{"doc":"","ref":"Starship.Reactor.html#process_request/3","title":"Starship.Reactor.process_request/3","type":"function"},{"doc":"","ref":"Starship.Reactor.html#websocket?/1","title":"Starship.Reactor.websocket?/1","type":"function"},{"doc":"The connection state of the port and socket. If set to :close , then the socket and port will return a Connection: Close header and close. If set to :keepalive , then the socket and port will return a Connection: Keep-Alive header and stay open.","ref":"Starship.Reactor.html#t:connection_state/0","title":"Starship.Reactor.connection_state/0","type":"type"},{"doc":"The configuration struct for the Starship Webserver.","ref":"Starship.Reactor.Config.html","title":"Starship.Reactor.Config","type":"module"},{"doc":"The configuration that is passed to the Webserver when started, and subsequently passed to every TCP process when spawned. The configuration contains both general server level configuration values (IP address, port, hosts, etc.) and TCP Socket level configuration values (socket process, socket state, socket handler, etc.)","ref":"Starship.Reactor.Config.html#t:t/0","title":"Starship.Reactor.Config.t/0","type":"type"},{"doc":"The connection struct for the Starship Webserver.","ref":"Starship.Reactor.Conn.html","title":"Starship.Reactor.Conn","type":"module"},{"doc":"","ref":"Starship.Reactor.Conn.html#http_method/1","title":"Starship.Reactor.Conn.http_method/1","type":"function"},{"doc":"","ref":"Starship.Reactor.Conn.html#http_version/1","title":"Starship.Reactor.Conn.http_version/1","type":"function"},{"doc":"The body of an HTTP request","ref":"Starship.Reactor.Conn.html#t:body/0","title":"Starship.Reactor.Conn.body/0","type":"type"},{"doc":"An HTTP header","ref":"Starship.Reactor.Conn.html#t:header/0","title":"Starship.Reactor.Conn.header/0","type":"type"},{"doc":"HTTP header list","ref":"Starship.Reactor.Conn.html#t:headers/0","title":"Starship.Reactor.Conn.headers/0","type":"type"},{"doc":"The HTTP version of a request","ref":"Starship.Reactor.Conn.html#t:http_version/0","title":"Starship.Reactor.Conn.http_version/0","type":"type"},{"doc":"The parsed query of an HTTP request","ref":"Starship.Reactor.Conn.html#t:query/0","title":"Starship.Reactor.Conn.query/0","type":"type"},{"doc":"A connection struct for an HTTP request made to the server. This defines all parts of the connection made to the server.","ref":"Starship.Reactor.Conn.html#t:t/0","title":"Starship.Reactor.Conn.t/0","type":"type"},{"doc":"The struct and type spec for HTTP Methods","ref":"Starship.Reactor.Conn.Method.html","title":"Starship.Reactor.Conn.Method","type":"module"},{"doc":"","ref":"Starship.Reactor.Conn.Method.html#connect/0","title":"Starship.Reactor.Conn.Method.connect/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Conn.Method.html#delete/0","title":"Starship.Reactor.Conn.Method.delete/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Conn.Method.html#get/0","title":"Starship.Reactor.Conn.Method.get/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Conn.Method.html#head/0","title":"Starship.Reactor.Conn.Method.head/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Conn.Method.html#options/0","title":"Starship.Reactor.Conn.Method.options/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Conn.Method.html#patch/0","title":"Starship.Reactor.Conn.Method.patch/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Conn.Method.html#post/0","title":"Starship.Reactor.Conn.Method.post/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Conn.Method.html#put/0","title":"Starship.Reactor.Conn.Method.put/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Conn.Method.html#trace/0","title":"Starship.Reactor.Conn.Method.trace/0","type":"function"},{"doc":"HTTP Methods according to HTTP Standards.","ref":"Starship.Reactor.Conn.Method.html#t:method/0","title":"Starship.Reactor.Conn.Method.method/0","type":"type"},{"doc":"A struct defining an HTTP Method and whether or not the method has a body. By default, GET , HEAD , CONNECT , OPTIONS , and TRACE methods have no body, while POST , PUT , DELETE , and PATCH methods have a body.","ref":"Starship.Reactor.Conn.Method.html#t:t/0","title":"Starship.Reactor.Conn.Method.t/0","type":"type"},{"doc":"Functions for handling HTTP Requests in Starship.Reactor .","ref":"Starship.Reactor.Http.html","title":"Starship.Reactor.Http","type":"module"},{"doc":"","ref":"Starship.Reactor.Http.html#handle_http_request/2","title":"Starship.Reactor.Http.handle_http_request/2","type":"function"},{"doc":"","ref":"Starship.Reactor.Http.html#handle_request_with_body/3","title":"Starship.Reactor.Http.handle_request_with_body/3","type":"function"},{"doc":"Functions for building responses that are returned to the client.","ref":"Starship.Reactor.Response.html","title":"Starship.Reactor.Response","type":"module"},{"doc":"","ref":"Starship.Reactor.Response.html#build_headers/2","title":"Starship.Reactor.Response.build_headers/2","type":"function"},{"doc":"","ref":"Starship.Reactor.Response.html#build_response/4","title":"Starship.Reactor.Response.build_response/4","type":"function"},{"doc":"","ref":"Starship.Reactor.Response.html#connection_header/2","title":"Starship.Reactor.Response.connection_header/2","type":"function"},{"doc":"All Response Codes that the Starship Webserver can currently return.","ref":"Starship.Reactor.Response.Codes.html","title":"Starship.Reactor.Response.Codes","type":"module"},{"doc":"","ref":"Starship.Reactor.Response.Codes.html#response/1","title":"Starship.Reactor.Response.Codes.response/1","type":"function"},{"doc":"Functions for handling Websocket Requests in Starship.Reactor .","ref":"Starship.Reactor.Websocket.html","title":"Starship.Reactor.Websocket","type":"module"},{"doc":"","ref":"Starship.Reactor.Websocket.html#handle_binary/2","title":"Starship.Reactor.Websocket.handle_binary/2","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.html#handle_close/2","title":"Starship.Reactor.Websocket.handle_close/2","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.html#handle_error/2","title":"Starship.Reactor.Websocket.handle_error/2","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.html#handle_fragment/3","title":"Starship.Reactor.Websocket.handle_fragment/3","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.html#handle_ping/2","title":"Starship.Reactor.Websocket.handle_ping/2","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.html#handle_pong/1","title":"Starship.Reactor.Websocket.handle_pong/1","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.html#handle_text/2","title":"Starship.Reactor.Websocket.handle_text/2","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.html#handle_ws_frame/2","title":"Starship.Reactor.Websocket.handle_ws_frame/2","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.html#handle_ws_handshake/2","title":"Starship.Reactor.Websocket.handle_ws_handshake/2","type":"function"},{"doc":"A websocket frame helper, used to parse and generate websocket frames.","ref":"Starship.Reactor.Websocket.Frame.html","title":"Starship.Reactor.Websocket.Frame","type":"module"},{"doc":"","ref":"Starship.Reactor.Websocket.Frame.html#generate_frame/2","title":"Starship.Reactor.Websocket.Frame.generate_frame/2","type":"function"},{"doc":"Parses a websocket frame into a readable payload (bitstring, binary, or nil values).","ref":"Starship.Reactor.Websocket.Frame.html#parse_frame/2","title":"Starship.Reactor.Websocket.Frame.parse_frame/2","type":"function"},{"doc":"A properly parsed websocket frame","ref":"Starship.Reactor.Websocket.Frame.html#t:frame/0","title":"Starship.Reactor.Websocket.Frame.frame/0","type":"type"},{"doc":"A websocket opcode","ref":"Starship.Reactor.Websocket.Frame.html#t:opcode/0","title":"Starship.Reactor.Websocket.Frame.opcode/0","type":"type"},{"doc":"Errors that occur when parsing a websocket frame","ref":"Starship.Reactor.Websocket.Frame.html#t:parse_error/0","title":"Starship.Reactor.Websocket.Frame.parse_error/0","type":"type"},{"doc":"Functions for handling a websocket handshake from Starship.Reactor.Websocket .","ref":"Starship.Reactor.Websocket.Handshake.html","title":"Starship.Reactor.Websocket.Handshake","type":"module"},{"doc":"","ref":"Starship.Reactor.Websocket.Handshake.html#build_handshake_reply_headers/2","title":"Starship.Reactor.Websocket.Handshake.build_handshake_reply_headers/2","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.Handshake.html#compress_handshake/2","title":"Starship.Reactor.Websocket.Handshake.compress_handshake/2","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.Handshake.html#extract_websocket_extensions/1","title":"Starship.Reactor.Websocket.Handshake.extract_websocket_extensions/1","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.Handshake.html#rejected_handshake/1","title":"Starship.Reactor.Websocket.Handshake.rejected_handshake/1","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.Handshake.html#successful_handshake/3","title":"Starship.Reactor.Websocket.Handshake.successful_handshake/3","type":"function"},{"doc":"Response Codes to be returned by a Websocket close frame.","ref":"Starship.Reactor.Websocket.ResponseCodes.html","title":"Starship.Reactor.Websocket.ResponseCodes","type":"module"},{"doc":"","ref":"Starship.Reactor.Websocket.ResponseCodes.html#client_terminating_due_to_unnegotiated_extension/0","title":"Starship.Reactor.Websocket.ResponseCodes.client_terminating_due_to_unnegotiated_extension/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.ResponseCodes.html#going_away/0","title":"Starship.Reactor.Websocket.ResponseCodes.going_away/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.ResponseCodes.html#normal_close/0","title":"Starship.Reactor.Websocket.ResponseCodes.normal_close/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.ResponseCodes.html#reserved_for_abnormal_closing/0","title":"Starship.Reactor.Websocket.ResponseCodes.reserved_for_abnormal_closing/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.ResponseCodes.html#reserved_for_failed_tls_handshake/0","title":"Starship.Reactor.Websocket.ResponseCodes.reserved_for_failed_tls_handshake/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.ResponseCodes.html#reserved_for_future_use/0","title":"Starship.Reactor.Websocket.ResponseCodes.reserved_for_future_use/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.ResponseCodes.html#reserved_for_no_status_code_present/0","title":"Starship.Reactor.Websocket.ResponseCodes.reserved_for_no_status_code_present/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.ResponseCodes.html#terminating_due_to_message_too_big_to_process/0","title":"Starship.Reactor.Websocket.ResponseCodes.terminating_due_to_message_too_big_to_process/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.ResponseCodes.html#terminating_due_to_not_consistent_data/0","title":"Starship.Reactor.Websocket.ResponseCodes.terminating_due_to_not_consistent_data/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.ResponseCodes.html#terminating_due_to_protocol_error/0","title":"Starship.Reactor.Websocket.ResponseCodes.terminating_due_to_protocol_error/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.ResponseCodes.html#terminating_due_to_unacceptable_data/0","title":"Starship.Reactor.Websocket.ResponseCodes.terminating_due_to_unacceptable_data/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.ResponseCodes.html#terminating_due_to_unexpected_condition/0","title":"Starship.Reactor.Websocket.ResponseCodes.terminating_due_to_unexpected_condition/0","type":"function"},{"doc":"","ref":"Starship.Reactor.Websocket.ResponseCodes.html#terminating_due_to_violated_policy/0","title":"Starship.Reactor.Websocket.ResponseCodes.terminating_due_to_violated_policy/0","type":"function"},{"doc":"The error that is raised when an unsupported HTTP Version is used in a request to the Starship Webserver.","ref":"Starship.Errors.HttpVersionNotSupportedError.html","title":"Starship.Errors.HttpVersionNotSupportedError","type":"exception"},{"doc":"The error that is raised when an invalid configuration is passed to Starship.warp_in/1 .","ref":"Starship.Errors.InvalidConfigurationError.html","title":"Starship.Errors.InvalidConfigurationError","type":"exception"},{"doc":"The error that is raised when an invalid handler type is passed to Starship.Reactor.get_host_handler/4 .","ref":"Starship.Errors.InvalidHandlerTypeError.html","title":"Starship.Errors.InvalidHandlerTypeError","type":"exception"},{"doc":"The error that is raised when an unsupported HTTP Method is used in a request to the Starship Webserver.","ref":"Starship.Errors.MethodNotAllowedError.html","title":"Starship.Errors.MethodNotAllowedError","type":"exception"},{"doc":"Starship A Fast Webserver written in Elixir.","ref":"readme.html","title":"Starship","type":"extras"},{"doc":"Currently, this is very much in alpha. I've taken the great work done by @van163 as a starting point and inspiration, in order to build up a fast Webserver in pure Elixir. I've fully rewritten the Elixir branch of @van163's work, cleaning it up, adding more Elixir structure and features to the project, splitting things into smaller and simpler functions, and adding proper functionalities to support various HTTP standards that the original server didn't support.","ref":"readme.html#status","title":"Starship - Status","type":"extras"},{"doc":"If available in Hex , the package can be installed by adding starship to your list of dependencies in mix.exs : def deps do [ { :starship , &quot;~&gt; 0.0.1&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/starship .","ref":"readme.html#installation","title":"Starship - Installation","type":"extras"},{"doc":"Simple support for HTTP/1.1 and below (No HTTP/2.0 or HTTP/3.0 yet) SSL (by passing SSL options to the config, which are subsequently passed to the :ssl erlang underlying application) Websockets I've tested basic text frames, and I've built out the functionality for fragmentations, however I need to find a way to test it Binary frames are currently not implemented","ref":"readme.html#current-features","title":"Starship - Current Features","type":"extras"},{"doc":"[ ] HTTP Standards [x] Support for HTTP/1.1 and below. [x] On HTTP/0.9 requests, we must close the connection on the server side after sending the response. [x] On HTTP/1.0 requests, we must close the connection unless a &quot;Connection: Keep-Alive&quot; Header is received from the client and then subsequently sent by the server. [x] On HTTP/1.1 requests, we only close the connection if a &quot;Connection: Close&quot; Header is received from the client, or if we send a &quot;Connection: Close&quot; Header from the server. [ ] Support for HTTP/2.0. [ ] Read the HTTP/2.0 standards and RFCs in order to support it correctly [x] Document how SSL options need to look in order to pass them through the configuration in the initial Starship.warp_in function. [ ] Optimize the parsing of request data for fastest performance. [x] Header Parsing and Organizing [ ] Cookie Parsing and Organizing [ ] Body Parsing and Organizing [ ] Websocket Standards [x] Make sure that Websocket Handshake and Handlers return the correct values for Starship.Reactor.connection_state . [ ] Parsing Websocket Frames. [ ] Receiving Data Frames: [x] Text [ ] Binary Starship should be able to decode the data frames as binary, however, the application using Starship needs to be able to receive and handle binary data, otherwise we will close the connection and return a termination error code [x] Ping [x] Continuation/Fragmentation [x] Close [ ] Generate Server Sent Data Frames: [x] Text [ ] Binary Check if encoding server sent data frames as binary is part of the standard If it is in the standard, Starship should be able to encode the data frames as binary. [x] Pong [x] Close [ ] Extras [ ] Write macros for building simple APIs (similar to how Plug works for Cowboy) [ ] Every Starship needs a Pilot Alternatively, write an adapter for Plug [ ] Create benchmarks on all aspects and write them out","ref":"readme.html#roadmap-todos","title":"Starship - Roadmap/TODOS","type":"extras"},{"doc":"The main credit here goes to @van163 for being frustrated with Elixir's standings in various benchmarks. After seeing his comments about this and his initial work, I decided to undertake this as a project in order to learn more about how web servers work and Elixir as a whole.","ref":"readme.html#credits","title":"Starship - Credits","type":"extras"},{"doc":"@van163's original project was done under a GNU GPLv3 License. I initially forked his repository in order to have a copy of the code for inspiration and to help me if I was getting stuck anywhere, but I ended up simply writing my code in the same repository. Since the entirety of the project is being written from scratch, and my intention was always (and still is) only to use @van163's work to help me understand how to write low level TCP code in Elixir and Erlang, I am going to be changing the license from the GNU GPLv3 License to my preferred MIT License. If someone sees an issue with this and has a valid argument, please open an issue, and I will gladly change it back to the GNU GPLv3 if it's necessary.","ref":"readme.html#license-remarks","title":"Starship - License Remarks","type":"extras"}]